/* This program is in the public domain.         */
/* Thomas Roessler <roessler@does-not-exist.org> */

#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>

#include <time.h>
#include <lastlog.h>
#include <fcntl.h>
#include <unistd.h>

char *Lastlog = "/var/log/lastlog";

int main (int argc, char *argv[])
{
  int i;
  int fd;
  struct lastlog ll;
  struct tm *tmptr;
  
  if (argc == 2)
    Lastlog = argv[1];
  else if (argc > 2)
  {
    fprintf (stderr, "Usage: %s [/var/log/lastlog]\n", argv[0]);
    return 1;
  }
  
  if ((fd = open (Lastlog, O_RDONLY)) == -1)
  {
    perror (Lastlog);
    return 1;
  }

  for (i = 0; read (fd, &ll, sizeof (ll)) == sizeof (ll); i++)
  {
    if (ll.ll_time == 0)
      continue;
    tmptr = localtime (&ll.ll_time);
    printf ("%5d\t%-10.10s\t%s", i, ll.ll_line, 
	    asctime (tmptr));
    if (*ll.ll_host)
      printf ("\t\t\t(from %s)\n", ll.ll_host);
  }
  
  close (fd);
  return 0;
}
      
  

