#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#include <sys/types.h>
#include <sys/socket.h>

static FILE *fp = NULL;

static void init_sendto (void)
{
  char *filename;
  
  if (fp) 
    return;
  if (!(filename = getenv ("SENDTO_LOG")))
  {
    fputs ("sendto.c: Please specify the log file in $SENDTO_LOG.\n", stderr);
    exit (1);
  }
  if (!(fp = fopen (filename, "w")))
  {
    fprintf (stderr, "sendto.c: Can't open %s. (%s)\n", filename, strerror (errno));
    exit (1);
  }
  setbuf (fp, NULL);
}

int  sendto(int s, const void *msg, size_t len, int flags,
	           const struct sockaddr *to, socklen_t tolen)
{
  int i;
  const unsigned char *buf = msg;
  init_sendto ();
  for (i = 0; i < len; i++)
  {
    if (i % 10 == 0) fputc ('\t', fp);
    fprintf (fp, "%s%02x", i%2 ? "" : " ", buf[i]);
    if (i % 10 == 9) fputc ('\n', fp);
  }
  fputs ("\n--\n", fp);
  return len;
}
